import fs from 'fs'

import client from './schemas/jm-client'
//import deletedRecord from './schemas/jm-deleted-record'
import certificationType from './schemas/jmc-certification-type'
import certification from './schemas/jmc-certification'
import internal from './schemas/jm-internal-fields'
import Complex from '../src/complex'

import toTypescriptSchema from '../src/ts-output'
import toMongooseSchema from '../src/mongoose-output'

let mongoosePrefix = `import mongoose from 'mongoose'\n// @ts-ignore -- ObjectId may or may not be used \nconst ObjectId = mongoose.Schema.Types.ObjectId\n\n`
const dir1 = __dirname + '/../../../jelpp-certificates/jelpp-microservice-framework/schemer'
const dir2 = __dirname + '/../../../jelpp-certificates/schemer'
fs.writeFileSync(dir1 + '/client.mongoose.ts', mongoosePrefix + client.mongoose, 'UTF-8')
fs.writeFileSync(dir1 + '/client.ts', client.typescript, 'UTF-8')
fs.writeFileSync(dir1 + '/internal.mongoose.ts', mongoosePrefix + internal.mongoose, 'UTF-8')
fs.writeFileSync(dir1 + '/internal.ts', internal.typescript, 'UTF-8')
//fs.writeFileSync(dir1 + '/deleted-record.mongoose.ts', mongoosePrefix + deletedRecord.mongoose, 'UTF-8')
//fs.writeFileSync(dir1 + '/deleted-record.ts', deletedRecord.typescript, 'UTF-8')
fs.writeFileSync(dir2 + '/certification-type.mongoose.ts', mongoosePrefix + certificationType.mongoose, 'UTF-8')
fs.writeFileSync(dir2 + '/certification-type.ts', certificationType.typescript, 'UTF-8')
fs.writeFileSync(dir2 + '/certification-type-jss-create.ts', certificationType.jsonCreate, 'UTF-8')
fs.writeFileSync(dir2 + '/certification-type-jss-update.ts', certificationType.jsonUpdate, 'UTF-8')
fs.writeFileSync(dir2 + '/certification.mongoose.ts', mongoosePrefix + certification.mongoose, 'UTF-8')
fs.writeFileSync(dir2 + '/certification.ts', certification.typescript, 'UTF-8')
fs.writeFileSync(dir2 + '/certification-jss-create.ts', certification.jsonCreate, 'UTF-8')
fs.writeFileSync(dir2 + '/certification-jss-update.ts', certification.jsonUpdate, 'UTF-8')

function toTypescript(name: string, obj: Complex): string {
  let schema = {
    fields: obj.subschema
  }
  return `
import mongoose from 'mongoose'
type ObjectId = mongoose.Types.ObjectId
  
${toTypescriptSchema(name, schema, 'typescript')}
  `
}

function toMongoose(name: string, obj: Complex) {
  return mongoosePrefix + toMongooseSchema(name, {fields: obj.subschema})
}
