import Complex from '../complex'
import {R2Author} from './r2-common'
import ObjectId from '../object-id'

export const R2Attachments = new Complex({
  _id: ObjectId,
  type: {type: String},
  employeeNotAllowedToDelete: {type: Boolean, optional: true},
  displayName: {type: String, optional: true},
  filename: String,
  mimeType: String,
  date: Date,
  finderId: {type: Number, index: true, optional: true},
  externalId: {type: String, optional: true},
  integrationPointId: Object,
  uploadedBy: {type: R2Author, optional: true},
  uploadedBySelf: {type: Boolean, optional: true},
  placeholder: {type: Boolean, optional: true},
  pending: {type: Boolean, optional: true},
  source: {type: String, enum: ['o2', 'ura'], optional: true},
  storage: {type: String, enum: ['finder', 's3', 'fs']},
  uploadedToPerson: {type: ObjectId, optional: true}
})
