import {R2Author} from './r2-common'
import Complex from '../complex'
import ObjectId from '../object-id'

export const R2Contract = new Complex({
  _id: ObjectId,
  finderId: { type:Number, index: true },
  begin: Date,
  end: {type: Date, optional: true},
  description: String,
  profession: String,
  allowance: String,
  pay: String,
  price: String,
  trips: String,
  meals: String,
  tools: String,
  company: { type: ObjectId, mongooseRef: 'Company', optional: true, index: true },
  commission: { type: ObjectId, mongooseRef: 'Commission', optional: true, index: true },
  industry: String,
  workExperience: { type: ObjectId },
  tes: String,
  priceMultiplier: Number,
  createdAt: Date,
  valid: { type: Boolean, mongooseDefault: false },
  synced: Boolean,
  frozen: { type: Boolean, mongooseDefault: false },
  updatedBy: R2Author,
  error: { type: ObjectId },
  madeByR2: Boolean
})
