import {R2Author} from './r2-common'
import Complex from '../complex'
import now from '../now'
import ObjectId from '../object-id'

export const R2Education = new Complex({
  _id: ObjectId,
  finderId: {type: Number, optional: true},
  externalId: {type: String, optional: true},
  degree: String,
  graduationYear: {type: String, optional: true},
  inProgress: Boolean,
  school: String,
  text: String,
  state: { type: String, enum: ['new', 'saved', 'editing', 'deleted'], mongooseDefault: 'saved', index: true },
  editClone: { optional: true, type: new Complex({
    author: R2Author,
    overwriteable: Boolean,
    date: {type: Date, mongooseDefault: now},
    lastEdited: Date,
    degree: String,
    graduationYear: String,
    inProgress: Boolean,
    school: String,
    text: String
  })}
})
