import {Schema} from '../schema'
import ObjectId from '../object-id'
import Complex from '../complex'
import toMongooseSchema from '../mongoose-output'
import toTypescriptSchema from '../ts-output'
import toJSONSchema from '../json-schema-output'
import now from '../now'

const schema: Schema = {
  fields: {
    _id: ObjectId,
    finderId: Number,
    name: String,
    deleted: Boolean
  }
}

export default {
  get mongoose() {
    return toMongooseSchema('finderCityMongooseSchema', schema)
  },
  get typescript() {
    return toTypescriptSchema('FinderCity', schema, 'typescript', { omitExtraExports: true })
  },
  get json() {
    return toJSONSchema('ExampleJSONSchema', schema, false)
  }
}
