import {R2Author} from './r2-common'
import Complex from '../complex'
import now from '../now'
import ObjectId from '../object-id'

export const R2WorkExperience = new Complex({
  _id: ObjectId,
  finderId: {type: Number, optional: true},
  externalId: {type: String, optional: true},
  employer: String,
  position: String,
  begin: Date,
  end: {type: Date, optional: true},
  termOfNotice: {type: Number, optional: true},
  termOfNoticeUnit: { type: String, enum: ['w', 'm'], mongooseDefault: 'w' },
  location: {type: String, optional: true},
  references: String,
  text: String,
  state: { type: String, enum: ['new', 'saved', 'editing', 'deleted'], mongooseDefault: 'saved', index: true },
  editClone: { optional: true, type: new Complex({
    author: R2Author,
    overwriteable: Boolean,
    date: {type: Date, mongooseDefault: now},
    lastEdited: Date,
    employer: String,
    position: String,
    begin: Date,
    end: Date,
    termOfNotice: Number,
    termOfNoticeUnit: String,
    location: String,
    references: String,
    text: String

  })}
})
